﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Text;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Drawing.Printing;


namespace PrintPicture001
{
    public partial class Form1 : Form
    {





        //input box
        public static class Prompt
        {
            public static string ShowDialog(string text, string caption)
            {
                Form prompt = new Form();
                prompt.Width = 400;
                prompt.Height = 85;
                prompt.BackColor = Color.White;
                prompt.FormBorderStyle = FormBorderStyle.FixedDialog;
                prompt.ControlBox = false;
                prompt.StartPosition = FormStartPosition.CenterScreen;
                prompt.Text = caption;

                TextBox text1 = new TextBox() { Left = 10, Top = 10, Width = 200 };
                text1.Font = new Font("Courier New",8);



                Button confirmation = new Button() { Text = "USE THIS VALUE", Left = 220, Width = 150, Top = 10 };
                confirmation.Font = new Font("Courier New", 8);

                // defailt button
                prompt.AcceptButton = confirmation;

                confirmation.Click += (sender, e) => { prompt.Close(); };
                prompt.Controls.Add(confirmation);
                prompt.Controls.Add(text1);

                // set focus
                text1.Select();

                prompt.ShowDialog();




                return text1.Text;



            }
        }






        public Form1()
        {
            InitializeComponent();
        }



        void pqr(object o, PrintPageEventArgs e)
        {

            // return image
            try
            {
                //new
                e.Graphics.PageUnit = GraphicsUnit.Inch;

                // added float from int
                e.Graphics.DrawImage(cnv.CanvasImage.Image, 0, 0, (float)Convert.ToDouble(docwidth.Text), (float)Convert.ToDouble(docheight.Text));
            }
            catch (Exception ee) { MessageBox.Show("Please check to see if document width and height values are valid."); }
        }





        private void button1_Click(object sender, EventArgs e)
        {




            try
            {

                // load into array from text box
                string textList = textList1.Text;
                string[] textListArray = textList.Split('\n');

                // draw main document into internal canvas
                Bitmap bmp1 = new Bitmap(LoadBox.Image);
                Graphics g = Graphics.FromImage(bmp1);
                //g.DrawImage(bmp1, 0, 0, Convert.ToInt32(docwidth.Text), Convert.ToInt32(docheight.Text));
                g.DrawImage(bmp1, 0, 0, LoadBox.Width, LoadBox.Height);

                // process lines and draw text on bitmap
                string font_text = FontList.Text;
                for (int j = 0; j < textListArray.Length; j++)
                {
                    if (textListArray[j].Trim().Length > 0)
                    {
                        g.DrawString(textListArray[j].Split(',')[1].Trim(), new Font(font_text, Convert.ToInt32(textListArray[j].Split(',')[4]), FontStyle.Bold), Brushes.Black, new Point(Convert.ToInt32(textListArray[j].Split(',')[2]), Convert.ToInt32(textListArray[j].Split(',')[3])));
                        //e.Graphics.DrawString(textBox1.Text.Trim(), new Font("Times New Roman", 14, FontStyle.Bold), Brushes.Black, new Point(100, 100));
                    }
                }

                // copy bitmap to output box
                cnv.CanvasImage.Image = bmp1;
               

                // redraw
                this.Refresh();
            }
            catch (Exception ee) { MessageBox.Show("There was an error generating the output image."); }




        }

        private void fileToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void saveCaptionsToolStripMenuItem_Click(object sender, EventArgs e)
        {

            try
            {

                SaveFileDialog saveFileDialog1 = new SaveFileDialog();
                saveFileDialog1.Filter = "MJC Files (*.mjc)|*.mjc|All Files (*.*)|*.*";
                saveFileDialog1.Title = "Save an document file";

                if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    File.WriteAllText(saveFileDialog1.FileName, docwidth.Text.Trim() + "\n");
                    File.AppendAllText(saveFileDialog1.FileName, docheight.Text.Trim() + "\n");
                    File.AppendAllText(saveFileDialog1.FileName, FontList.Text + "\n");
                    File.AppendAllText(saveFileDialog1.FileName, textList1.Text + "\n");
                }

            }
            catch (Exception ee) { MessageBox.Show("There was an error saving the text fields."); }




        }

        private void loadImageToolStripMenuItem_Click(object sender, EventArgs e)
        {

            try
            {

                OpenFileDialog dialog = new OpenFileDialog();
                dialog.Filter = "JPEG Files (*.jpg)|*.jpg|All Files (*.*)|*.*";
                dialog.Title = "Select your document image";

                if (dialog.ShowDialog() == DialogResult.OK)
                {
                    cnv.CanvasImage.ImageLocation = dialog.FileName;
                    LoadBox.ImageLocation = dialog.FileName;
                }

            }
            catch (Exception ee) { MessageBox.Show("There was an error loading the document image."); }



        }

        private void loadCaptionsToolStripMenuItem_Click(object sender, EventArgs e)
        {

            try
            {
                OpenFileDialog dialog = new OpenFileDialog();
                dialog.Filter = "MJC Files (*.mjc)|*.mjc|All Files (*.*)|*.*";
                dialog.Title = "Select your document file";

                // scrape width height and font
                string loadAll = "";
                string[] lines1 = { };


                if (dialog.ShowDialog() == DialogResult.OK)
                {
                    //textList1.Text = File.ReadAllText(dialog.FileName);
                    loadAll = File.ReadAllText(dialog.FileName);
                    lines1 = loadAll.Split('\n');

                    double width1 = Convert.ToDouble(lines1[0]);
                    double height1 = Convert.ToDouble(lines1[1]);
                    string font1 = lines1[2].Trim();

                    // populate fields
                    docwidth.Text = width1.ToString().Trim();
                    docheight.Text = height1.ToString().Trim();
                    FontList.Text = font1.Trim();

                    // load the rest of the file
                    textList1.Text = "";
                    for (int j = 3; j < lines1.Length; j++)
                    {
                        textList1.Text += lines1[j] + "\n";
                    }

                }






            }
            catch (Exception ee) { MessageBox.Show("There was an error loading the text fields."); }

        }

        private void panel1_Paint(object sender, PaintEventArgs e)
        {

        }

        private void button2_Click(object sender, EventArgs e)
        {
            try
            {
                PrintDialog pd = new PrintDialog();
                pd.PrinterSettings = new PrinterSettings();
                if (DialogResult.OK == pd.ShowDialog(this))
                {
                    PrintDocument pdoc = new PrintDocument();

                    //new printer select
                    pdoc.PrinterSettings.PrinterName = pd.PrinterSettings.PrinterName;

                    pdoc.PrintPage += new PrintPageEventHandler(pqr);
                    pdoc.Print();
                }
            }
            catch (Exception ee) { MessageBox.Show("There was an error printing."); }
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {

        }




        //load canvas
        Canvas cnv = new Canvas();
        private void Form1_Load(object sender, EventArgs e)
        {

            //load fonts
            var fonts = new InstalledFontCollection();
            foreach (FontFamily font in fonts.Families)
            {
                FontList.Items.Add(font.Name);
            }
            FontList.SelectedIndex = 0;

            //load canvas
            cnv.Show();
            cnv.BringToFront();


            //this left top
            this.Left = (System.Windows.Forms.SystemInformation.PrimaryMonitorSize.Width - this.Width) - 35;
            this.Top = 35;


            this.BringToFront();

            // populate output image
            cnv.CanvasImage.Image = this.LoadBox.Image;


  


        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            using (Form abtForm = new About1())
            {
                abtForm.ShowDialog(this);
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void label5_Click(object sender, EventArgs e)
        {

        }

        private void label2_Click(object sender, EventArgs e)
        {

        }

        private void LoadBox_MouseMove(object sender, MouseEventArgs e)
        {
            toolStripStatusLabel1.Text = "COORDS: " + e.X.ToString() + ", " + e.Y.ToString();
        }

        private void LoadBox_Click(object sender, EventArgs e)
        {
            
        }









        private void LoadBox_MouseDown(object sender, MouseEventArgs e)
        {

            // added field prompts
            string label1 = Prompt.ShowDialog("PLEASE ENTER FIELD LABEL.", "INPUT FIELD LABEL");
            string text1 = Prompt.ShowDialog("PLEASE ENTER FIELD TEXT.", "INPUT FIELD TEXT");
            double fontsize1 = Convert.ToDouble(Prompt.ShowDialog("PLEASE ENTER FONT SIZE.", "INPUT FONT SIZE"));

            textList1.Text += Environment.NewLine + label1 + ", " + text1 + ", " + e.X.ToString() + ", " + e.Y.ToString() + ", " + fontsize1.ToString().Trim();
        }

        private void printToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {

                SaveFileDialog saveFileDialog1 = new SaveFileDialog();
                saveFileDialog1.Filter = "JPEG Files (*.jpg)|*jpg|All Files (*.*)|*.*";
                saveFileDialog1.Title = "Save output image";

                if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                { 
                    cnv.CanvasImage.Image.Save(saveFileDialog1.FileName,System.Drawing.Imaging.ImageFormat.Jpeg);
                }

            }
            catch (Exception ee) { MessageBox.Show("There was an error saving the output image."); }
        }

        private void textList1_TextChanged(object sender, EventArgs e)
        {

        }

        private void label3_Click(object sender, EventArgs e)
        {

        }

        private void menuStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {

        }

        private void button4_Click(object sender, EventArgs e)
        {
            textList1.Text = "";
        }

        private void Form1_SizeChanged(object sender, EventArgs e)
        {

        }

        private void button5_Click(object sender, EventArgs e)
        {
;
        }
    }
}
